/*
 * blueMail offline mail reader
 * BBBS driver

 Copyright (c) 2002 Ingo Brueckl <ib@wupperonline.de>

 Distributed under the GNU General Public License.
 For details, see the file COPYING in the parent directory. */

#ifndef BBBS_H
#define BBBS_H


#include "../bmail.h"
#include "alldrv.h"

#define __BBBS_NO_EXTERNS__
#include "bbbsdef.h"
#undef true
#undef false
struct userconfstat
{
  unlong lastread;
  unlong status;
};


class bbbs : public main_driver
{
  private:
    bmail *bm;
    int NAID, NLID, currentArea;
    int maxAreas;
    struct BBBS_AREA_INFO
    {
      char *title;
      unlong status;
      int totmsgs;
      int numpers;
      unlong first;
      bool isEmail;
    } *areas;
    PERSIDX *persIDX;
    int persmsgs;
    bool persArea;
    struct BODYTYPE
    {
      bool extraline;
      unlong lines;
      long pointer;
    } **body;
    char *letterBody;
    char error[80];
    static struct TREE
    {
      short c0;
      short c1;
    } tree[];
    char *unpacked;
    enum filetype {NONE, DAT, TXT};
    bool user0;
    FILE *msgdat;

    bool getAreas();
    bool openFile(int, filetype);
    int buildIndices();
    int unpack(byte *);
    void addLetterBody(int);

  public:
    bbbs(bmail *);
    ~bbbs();
    const char *init();
    int getNoOfAreas();
    area_header *getNextArea();
    void selectArea(int);
    int getNoOfLetters();
    letter_header *getNextLetter();
    const char *getBody(int, int, letter_header *);
    void resetLetters();
    void initMSF(int **);
    int readMSF(int **);
    const char *saveMSF(int **);
    bool isLatin1();
    const char **getBulletins();
    int persOffset() const;          // for access from bbbs_reply only
    char *getConfFile(int);          // for access from bbbs_reply only
};


#endif
