/*
 * blueMail offline mail reader
 * Hippo v2 driver

 Copyright (c) 2002 Ingo Brueckl <ib@wupperonline.de>

 Distributed under the GNU General Public License.
 For details, see the file COPYING in the parent directory. */

#ifndef HIPPO_H
#define HIPPO_H


#include "../bmail.h"
#include "alldrv.h"


class hippo : public main_driver
{
  private:
    bmail *bm;
    alldriver *alldrv;
    int NAID, NLID, currentArea;
    int maxAreas;
    struct HIPPO_AREA_INFO
    {
      char *title;
      int flags;
      int totmsgs;
      int numpers;
      HIPPO_AREA_INFO *next;
    } **areas;
    PERSIDX *persIDX;
    int persmsgs;
    bool persArea;
    bodytype **body;
    char *letterBody;
    char packetID[9];
    char line[MAXLINELEN];
    FILE *hd;

    int buildIndices();
    HIPPO_AREA_INFO *newArea(HIPPO_AREA_INFO *);
    int getAreaIndex(HIPPO_AREA_INFO *, const char *) const;
    HIPPO_AREA_INFO *getArea(HIPPO_AREA_INFO *, int) const;

  public:
    hippo(bmail *);
    ~hippo();
    const char *init();
    int getNoOfAreas();
    area_header *getNextArea();
    void selectArea(int);
    int getNoOfLetters();
    letter_header *getNextLetter();
    const char *getBody(int, int, letter_header *);
    void resetLetters();
    void initMSF(int **);
    int readMSF(int **);
    const char *saveMSF(int **);
    bool isLatin1();
    const char **getBulletins();
    const char *getPacketID() const;       // for access from hippo_reply only
    int persOffset() const;                // for access from hippo_reply only
    const char *getAreaInfo(int *)const;   // for access from hippo_reply only
};


#endif
