/*
 * blueMail offline mail reader
 * Hudson Message Base driver

 Copyright (c) 2002 Ingo Brueckl <ib@wupperonline.de>

 Distributed under the GNU General Public License.
 For details, see the file COPYING in the parent directory. */

#ifndef HMB_H
#define HMB_H


#include "../bmail.h"
#include "alldrv.h"

#ifndef BIG_ENDIAN
  #define BIG_ENDIAN
#endif
#include "hudson.h"


class hmb : public main_driver
{
  private:
    bmail *bm;
    alldriver *alldrv;
    int NAID, NLID, currentArea;
    int maxAreas;
    struct
    {
      unsigned char number;
      char shortname[4];
      char *title;
      unsigned int lastread;
      int numpers;
    } board[201];              // 200 plus one for the personal area
    bool isNetmail[200];
    struct PERSHIDX
    {
      unsigned int msgnum;
      unsigned char area;
      int letter;
    } *persHIDX;
    int persmsgs;
    bool persArea;
    bodytype **body;
    char *letterBody;
    HMB_INFO hmb_info;
    char error[80];
    FILE *idx, *hdr, *txt;

    FILE *openFile(const char *);
    int getPersIndices();
    int getAreas();
    void getNextHdr(HMB_HDR *, int, bool) const;
    int getAreaIndex (unsigned char) const;

  public:
    hmb(bmail *);
    ~hmb();
    const char *init();
    int getNoOfAreas();
    area_header *getNextArea();
    void selectArea(int);
    int getNoOfLetters();
    letter_header *getNextLetter();
    const char *getBody(int, int, letter_header *);
    void resetLetters();
    void initMSF(int **);
    int readMSF(int **);
    const char *saveMSF(int **);
    bool isLatin1();
    const char **getBulletins();
};


#endif
