/*
 * blueMail offline mail reader
 * OMEN driver

 Copyright (c) 2002 Ingo Brueckl <ib@wupperonline.de>

 Distributed under the GNU General Public License.
 For details, see the file COPYING in the parent directory. */

#ifndef OMEN_H
#define OMEN_H


#include "../bmail.h"
#include "alldrv.h"


// OMEN area flags
#define BrdStatus_WRITE      1
#define BrdStatus_SYSOP      2
#define BrdStatus_PRIVATE    4
#define BrdStatus_PUBLIC     8
#define BrdStatus_NETMAIL   16
#define BrdStatus_ALIAS     32
#define BrdStatus_SELECTED  64
#define BrdStatus_reserved 128


class omen : public main_driver
{
  private:
    bmail *bm;
    alldriver *alldrv;
    int NAID, NLID, currentArea;
    int maxAreas;
    struct OMEN_AREA_INFO
    {
      int number;
      char shortname[17];
      char *title;
      int flags;
      int totmsgs;
      int numpers;
    } *areas;
    PERSIDX *persIDX;
    int persmsgs;
    bool persArea;
    bodytype **body;
    char *letterBody;
    const char **bulletins;
    char packetID[3];
    bool c_set_iso;
    char line[MAXLINELEN];
    FILE *newmsg;

    int persOffset() const;
    bool getAreas(FILE *);
    void readInfo();
    int buildIndices();
    int getAreaIndex(int) const;

  public:
    omen(bmail *);
    ~omen();
    const char *init();
    int getNoOfAreas();
    area_header *getNextArea();
    void selectArea(int);
    int getNoOfLetters();
    letter_header *getNextLetter();
    const char *getBody(int, int, letter_header *);
    void resetLetters();
    void initMSF(int **);
    int readMSF(int **);
    const char *saveMSF(int **);
    bool isLatin1();
    const char **getBulletins();
    const char *getPacketID() const;     // for access from omen_reply only
};


#endif
