/*
 * blueMail offline mail reader
 * SOUP driver

 Copyright (c) 2002 Ingo Brueckl <ib@wupperonline.de>

 Distributed under the GNU General Public License.
 For details, see the file COPYING in the parent directory. */

#ifndef SOUP_H
#define SOUP_H


#include "../bmail.h"
#include "alldrv.h"


class soup : public main_driver
{
  private:
    bmail *bm;
    alldriver *alldrv;
    int NAID, NLID, currentArea;
    int maxAreas;
    struct SOUP_AREA_INFO
    {
      char number[12];
      char *prefix;
      char format;
      char index;
      bool isEmail;
      int totmsgs;
      long offset;
      SOUP_AREA_INFO *next;
    } **areas;
    long **headerlines;
    bodytype **body;
    char *letterBody;
    const char **bulletins;
    char error[80];
    char line[MAXLINELEN];
    FILE *areasFile, *msgFile;

    bool getAreas();
    bool buildIndices();
    bool openFile(SOUP_AREA_INFO *);

  public:
    soup(bmail *);
    ~soup();
    const char *init();
    int getNoOfAreas();
    area_header *getNextArea();
    void selectArea(int);
    int getNoOfLetters();
    letter_header *getNextLetter();
    const char *getBody(int, int, letter_header *);
    void resetLetters();
    void initMSF(int **);
    int readMSF(int **);
    const char *saveMSF(int **);
    bool isLatin1();
    const char **getBulletins();
};


#endif
