/*
 * blueMail offline mail reader
 * Unix mail file (Berkeley format - mbox) driver

 Copyright (c) 2002 Ingo Brueckl <ib@wupperonline.de>

 Distributed under the GNU General Public License.
 For details, see the file COPYING in the parent directory. */

#ifndef UNIXMAIL_H
#define UNIXMAIL_H


#include <stdio.h>
#include "../bmail.h"
#include "alldrv.h"


class unixmail : public main_driver
{
  private:
    bmail *bm;
    alldriver *alldrv;
    int NLID, totmsgs;
    struct MSG_INFO
    {
      long top;
      long header;
      long status;
      long x_status;
      long body;
      long end;
      int stat;
      long headerlines;
      MSG_INFO *next;
    } *anchor, **msg;
    char *letterBody;
    char line[MAXLINELEN];
    char lockfile[MYMAXPATH + 6];
    const char *mfile;
    FILE *mbox;

    void buildIndices();
    const char *Status(int) const;
    void catastrophe(bool, const char *) const;

  public:
    unixmail(bmail *);
    ~unixmail();
    const char *init();
    int getNoOfAreas();
    area_header *getNextArea();
    void selectArea(int);
    int getNoOfLetters();
    letter_header *getNextLetter();
    const char *getBody(int, int, letter_header *);
    void resetLetters();
    void initMSF(int **);
    int readMSF(int **);
    const char *saveMSF(int **);
    bool isLatin1();
    const char **getBulletins();
};


#endif
